unit uBizPresupuestosServer;

interface

uses
  schPresupuestosServer_Intf, uDAInterfaces,
  uDADataTable, uDABusinessProcessor;

const
  BIZ_SERVER_PRESUPUESTO = 'Server.Presupuesto';
  REF_PRESUPUESTOS = 'REF_PRESUPUESTOS';

  SITUACION_PENDIENTE = 'Pendiente';
  SITUACION_ACEPTADO = 'Aceptado';
  SITUACION_RECHAZADO = 'Rechazado';

type
  TBizPresupuestoServer = class(TPresupuestosBusinessProcessorRules)
  protected
    procedure BeforeProcessChange(Sender: TDABusinessProcessor;
      aChangeType: TDAChangeType; aChange: TDADeltaChange;
      var ProcessChange: Boolean); override;
  end;

implementation

uses
  SysUtils, Variants, uDataModuleServer, uDAClasses, DARemoteService_Impl,
  schPresupuestosClient_Intf, uBusinessUtils, uReferenciasUtils, uROClasses;

{ TBizPresupuestosServer }

procedure TBizPresupuestoServer.BeforeProcessChange(
  Sender: TDABusinessProcessor; aChangeType: TDAChangeType;
  aChange: TDADeltaChange; var ProcessChange: Boolean);
var
  ASchema : TDASchema;
  ACurrentConn : IDAConnection;
  dsData: IDADataset;
  Empresa : Variant;

begin
  inherited;
  case aChangeType of
    ctInsert, ctUpdate: begin
      //Si la referencia no ha sido asignada le asignamos una nosotros
      if (VarIsNull(aChange.NewValueByName[fld_PresupuestosREFERENCIA]))
      or (VarToStr(aChange.NewValueByName[fld_PresupuestosREFERENCIA]) = '') then
      begin
        ASchema := BusinessProcessor.Schema;
        ACurrentConn := GetBusinessProcessorConnection(BusinessProcessor);

        try
          //Siempre va a estar rellena
          Empresa := aChange.NewValueByName[fld_PresupuestosID_EMPRESA];

          dsData := ASchema.NewDataset(ACurrentConn, 'DarReferencia', ['CODIGO', 'EMPRESA'], [REF_PRESUPUESTOS, Empresa]);
        except
          RaiseError('No existe la tabla REFERENCIAS');
        end;

        dsData.Active := True;

        if dsData.IsEmpty then
          RaiseError('NO HAY REFERENCIA ' + REF_PRESUPUESTOS + ' DECLARADA EN TABLA REFERENCIAS');

        REFERENCIA := dsData.FieldByName('VALOR').AsString;

        try
          ASchema.NewCommand(ACurrentConn, 'ModificarReferencia', ['CODIGO', 'VALOR', 'EMPRESA'], [REF_PRESUPUESTOS, darReferenciaSiguiente(REFERENCIA), Empresa]);
        except
          RaiseError('Error al asignar la nueva ' + REFERENCIA + ' referencia en tabla');
        end;

      end;
    end;
  end;
end;

initialization
  RegisterBusinessProcessorRules(BIZ_SERVER_PRESUPUESTO, TBizPresupuestoServer);

end.
